var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, EventEmitter, HostListener, Input, Output } from '@angular/core';
import { animate, state, style, transition, trigger } from '@angular/animations';
import { Dialog } from './dialog';
var DialogComponent = /** @class */ (function () {
    function DialogComponent() {
        this.onClick = new EventEmitter();
        this.modalFadeIn = false;
        this.modalState = 'inactive';
    }
    DialogComponent.prototype.ngOnInit = function () {
        var _this = this;
        //need to fade in the modal
        this.modalFadeIn = true;
        setTimeout(function () { return _this.modalState = 'active'; });
    };
    DialogComponent.prototype.closeModal = function () {
        this.btnClick(0);
    };
    DialogComponent.prototype.btnClick = function (val) {
        var _this = this;
        this.modalState = 'inactive';
        // 300ms this much time the animation takes to close the modal
        setTimeout(function () {
            _this.onClick.emit(val);
            _this.modalFadeIn = false;
        }, 300);
    };
    DialogComponent.prototype.onActionKeyPress = function (event) {
        var currentDefaultIndex = this.dialog.actionButtons.findIndex(function (i) { return i.default; });
        this.dialog.actionButtons[currentDefaultIndex].default = false;
        var len = this.dialog.actionButtons.length;
        if (event.keyCode == 37) { // Left arrow
            var newDefaultIndex = ((currentDefaultIndex - 1) + len) % len;
            this.dialog.actionButtons[newDefaultIndex].default = true;
        }
        else if (event.keyCode == 39) { // Right arrow
            var newDefaultIndex = ((currentDefaultIndex - 1) + len) % len;
            this.dialog.actionButtons[newDefaultIndex].default = true;
        }
        else if (event.keyCode == 13) { // Enter
            this.btnClick(this.dialog.actionButtons[currentDefaultIndex].value);
        }
        else if (event.keyCode == 27) { // Esc key
            this.btnClick(0);
        }
    };
    __decorate([
        Input(),
        __metadata("design:type", Dialog)
    ], DialogComponent.prototype, "dialog", void 0);
    __decorate([
        Output('pfDialogClick'),
        __metadata("design:type", Object)
    ], DialogComponent.prototype, "onClick", void 0);
    __decorate([
        HostListener('window:keydown', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], DialogComponent.prototype, "onActionKeyPress", null);
    DialogComponent = __decorate([
        Component({
            animations: [
                trigger('modalState', [
                    state('inactive', style({
                        opacity: '0',
                        transform: 'translateY(-50%)'
                    })),
                    state('active', style({
                        opacity: '1',
                        transform: 'translateY(0)'
                    })),
                    transition('inactive <=>active', animate('500ms ease-in'))
                ]),
                trigger('modalOverlay', [
                    state('inactive', style({
                        background: 'transparent'
                    })),
                    state('active', style({
                        background: 'rgba(0,0,0,0.4)'
                    })),
                    transition('inactive <=>active', animate('500ms ease-in'))
                ])
            ],
            selector: 'alm-dialog',
            styles: [require('./dialog.component.css').toString()],
            template: "<div class=\"modal\" id=\"alm-modal\" tabindex=\"-1\" role=\"dialog\" [ngClass]=\"{'show': modalFadeIn,'hide':!modalFadeIn}\" [@modalOverlay]=\"modalState\" aria-labelledby=\"almModal\" aria-hidden=\"false\"><div class=\"modal-dialog\" [@modalState]=\"modalState\"><div class=\"modal-content\"><div class=\"modal-header\"><button type=\"button\" class=\"close\" (click)=\"closeModal()\" data-dismiss=\"modal\" aria-hidden=\"true\"><span class=\"pficon pficon-close\"></span></button><h4 *ngIf=\"dialog.title\">{{ dialog.title ? dialog.title : '' }}</h4></div><div class=\"modal-body\"><div class=\"product-versions-pf\"><span *ngIf=\"dialog.message\" id=\"alm-dialog-message\">{{ dialog.message ? dialog.message : '' }}</span></div></div><div *ngIf=\"dialog.actionButtons\" class=\"modal-footer\"><button *ngFor=\"let btn of dialog.actionButtons\" type=\"submit\" class=\"btn marginR10 pull-left\" [class.btn-primary]=\"btn.default\" value=\"{{ btn.value}}\" (click)=\"btnClick(btn.value)\">{{ btn.title }}</button></div></div></div></div>"
        }),
        __metadata("design:paramtypes", [])
    ], DialogComponent);
    return DialogComponent;
}());
export { DialogComponent };
//# sourceMappingURL=dialog.component.js.map