var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, EventEmitter, Input, Output } from '@angular/core';
import { DropdownOption } from './dropdown-option';
var DropdownComponent = /** @class */ (function () {
    function DropdownComponent() {
        this.onUpdate = new EventEmitter();
        this.show = false;
    }
    DropdownComponent.prototype.ngOnInit = function () {
    };
    DropdownComponent.prototype.toggle = function () {
        this.show = !this.show;
    };
    DropdownComponent.prototype.open = function () {
        this.show = true;
    };
    DropdownComponent.prototype.close = function () {
        this.show = false;
    };
    DropdownComponent.prototype.onChange = function (option) {
        this.onUpdate.emit({
            currentOption: this.selected,
            newOption: option
        });
        this.toggle();
    };
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], DropdownComponent.prototype, "options", void 0);
    __decorate([
        Input(),
        __metadata("design:type", DropdownOption)
    ], DropdownComponent.prototype, "selected", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], DropdownComponent.prototype, "disabled", void 0);
    __decorate([
        Output('change'),
        __metadata("design:type", Object)
    ], DropdownComponent.prototype, "onUpdate", void 0);
    DropdownComponent = __decorate([
        Component({
            selector: 'alm-dropdown',
            styles: [require('./dropdown.component.css').toString()],
            template: "<div *ngIf=\"selected\" class=\"dropdown card-pf-time-frame-filter\"><button (click)=\"toggle()\" type=\"button\" class=\"btn dropdown-toggle alm-dropdown-btn {{selected.active_class ? selected.active_class : 'btn-default'}}\" data-toggle=\"dropdown\">{{selected.option}} <span *ngIf=\"!disabled\" class=\"caret\"></span></button><ul *ngIf=\"show && !disabled\" class=\"dropdown-menu dropdown-menu-left\" style=\"display:block\" role=\"menu\"><li *ngFor=\"let option of options;\" class=\"{{option.option_class}}\" (click)=\"onChange(option)\"><a>{{option.option}}</a></li></ul></div>"
        }),
        __metadata("design:paramtypes", [])
    ], DropdownComponent);
    return DropdownComponent;
}());
export { DropdownComponent };
//# sourceMappingURL=dropdown.component.js.map