var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Directive, ElementRef, EventEmitter, HostListener, Input, Output } from '@angular/core';
var AlmEditableDirective = /** @class */ (function () {
    function AlmEditableDirective(elementRef) {
        this.elementRef = elementRef;
        this.onUpdate = new EventEmitter();
        this.editable = true;
        this.content = '';
        this.element = this.elementRef.nativeElement;
    }
    AlmEditableDirective.prototype.ngOnInit = function () {
        this.element.style.whiteSpace = 'pre-wrap';
        if (this.editable) {
            this.makeEditable();
        }
    };
    AlmEditableDirective.prototype.ngOnChanges = function () {
        if (this.editable) {
            this.makeEditable();
        }
        else {
            this.makeNonEditable();
        }
    };
    AlmEditableDirective.prototype.onEdit = function () {
        var newContent = this.element.innerText;
        if (this.content !== newContent) {
            this.content = newContent;
            this.onUpdate.emit(this.content);
        }
    };
    AlmEditableDirective.prototype.makeEditable = function () {
        this.element.setAttribute('contenteditable', 'true');
        this.element.focus();
    };
    AlmEditableDirective.prototype.makeNonEditable = function () {
        this.element.removeAttribute('contenteditable');
    };
    AlmEditableDirective.prototype.listenToKeypress = function (event) {
        if (this.editable) {
            this.onEdit();
        }
    };
    AlmEditableDirective.prototype.focusField = function () {
        var _this = this;
        setTimeout(function () {
            if (_this.element.childNodes.length) {
                var range = document.createRange();
                var sel = window.getSelection();
                range.setStart(_this.element.childNodes[_this.element.childNodes.length - 1], _this.element.childNodes[_this.element.childNodes.length - 1].childNodes.length);
                range.collapse(true);
                sel.removeAllRanges();
                sel.addRange(range);
            }
        });
    };
    __decorate([
        Output('onUpdate'),
        __metadata("design:type", Object)
    ], AlmEditableDirective.prototype, "onUpdate", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], AlmEditableDirective.prototype, "editable", void 0);
    __decorate([
        HostListener('window:keyup', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], AlmEditableDirective.prototype, "listenToKeypress", null);
    __decorate([
        HostListener('focus'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], AlmEditableDirective.prototype, "focusField", null);
    AlmEditableDirective = __decorate([
        Directive({
            selector: '[almEditable]',
            exportAs: 'almEditable'
        }),
        __metadata("design:paramtypes", [ElementRef])
    ], AlmEditableDirective);
    return AlmEditableDirective;
}());
export { AlmEditableDirective };
//# sourceMappingURL=almeditable.directive.js.map