import { AfterViewChecked, ElementRef, EventEmitter, OnChanges, SimpleChanges } from '@angular/core';
import { DomSanitizer, SafeHtml } from '@angular/platform-browser';
import { GitHubLinkService } from './github-link.service';
/**
 * GitHub Link Area component. This shows a formatted link to GitHub with an
 * indicator of whether the GitHub issue is open or closed in an text area.
 * Works only for public remote repositories for now. See example for how to
 * use this.
 */
export declare class GitHubLinkAreaComponent implements OnChanges, AfterViewChecked {
    private gitHubLinkService;
    private elementRef;
    private sanitizer;
    content: string | SafeHtml;
    onInputEvent: EventEmitter<{}>;
    constructor(gitHubLinkService: GitHubLinkService, elementRef: ElementRef, sanitizer: DomSanitizer);
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterViewChecked(): void;
    updateOnChanges(): void;
    instrumentInputs(): void;
    wrapStringSafeValue(input: string | SafeHtml): SafeHtml;
    unwrapStringSafeValue(input: any): any;
    replaceLink(linkData: any): void;
    updateLinkTexts(): void;
    updateLinks(): void;
}
