import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
/**
 * This is the Type used for the data returned from Github
 */
export interface Gh_issue {
    match: string;
    org: string;
    repo: string;
    issue: string;
    state?: string;
    url?: string;
}
/**
 * This provides a very simple retrieval of issue information from
 * GitHub. It uses the non-authorized public API of GitHub, so it
 * is rate-limited (to 60 requests/hr currently). To avoid as much
 * requests as possible, the request responses are cached here.
 */
export declare class GitHubLinkService {
    private http;
    private linkCache;
    constructor(http: HttpClient);
    getIssue(linkData: Gh_issue): Observable<Gh_issue>;
    private findInCache;
}
