var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Directive, ElementRef, Input } from '@angular/core';
import { IconMap } from './iconmap';
var AlmIconDirective = /** @class */ (function () {
    function AlmIconDirective(elementRef) {
        this.elementRef = elementRef;
        this.iconType = 'none';
    }
    AlmIconDirective.prototype.ngOnInit = function () {
        this.addIcon();
    };
    AlmIconDirective.prototype.ngOnChanges = function () {
        this.addIcon();
    };
    AlmIconDirective.prototype.addIcon = function () {
        var iconColor = 'none';
        var element = this.elementRef.nativeElement;
        var existingClassNames = element.className.split(' ');
        var allClassesInMap = [];
        for (var key in IconMap) {
            if (IconMap.hasOwnProperty(key)) {
                IconMap[key].icon.forEach(function (item) {
                    allClassesInMap.push(item);
                });
            }
        }
        existingClassNames.forEach(function (item) {
            if (allClassesInMap.indexOf(item) > -1) {
                element.classList.remove(item);
            }
        });
        if (this.iconType in IconMap) {
            iconColor = IconMap[this.iconType].color;
            element.setAttribute('style', 'color:' + iconColor);
            IconMap[this.iconType].icon.forEach(function (item) {
                element.classList.add(item);
            });
        }
        else {
            iconColor = IconMap['default'].color;
            element.setAttribute('style', 'color:' + iconColor);
            IconMap['default'].icon.forEach(function (item) {
                element.classList.add(item);
            });
        }
    };
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], AlmIconDirective.prototype, "iconType", void 0);
    AlmIconDirective = __decorate([
        Directive({
            selector: '[almIcon]',
            exportAs: 'almIcon'
        }),
        __metadata("design:paramtypes", [ElementRef])
    ], AlmIconDirective);
    return AlmIconDirective;
}());
export { AlmIconDirective };
//# sourceMappingURL=almicon.directive.js.map