var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Directive, ElementRef, EventEmitter, HostListener, Input, Output } from '@angular/core';
var InfiniteScrollDirective = /** @class */ (function () {
    function InfiniteScrollDirective(elementRef) {
        this.elementRef = elementRef;
        this.initItems = new EventEmitter();
        this.fetchMore = new EventEmitter();
        this.eachElementHeightInPx = 20;
        this.fetchThreshold = 5;
        this.pageSize = 10;
        this.lastCheckedHeight = 0;
        this.previousScrollHeight = 0;
        this.element = this.elementRef.nativeElement;
    }
    InfiniteScrollDirective.prototype.ngOnInit = function () {
        this.pageSize = Math.ceil(this.element.offsetHeight / this.eachElementHeightInPx);
        // Page should always have more elements than it can hold
        // Normally twice than threshold value
        this.pageSize += this.fetchThreshold * 2;
        this.initContentItems();
    };
    InfiniteScrollDirective.prototype.initContentItems = function () {
        this.initItems.emit({
            pageSize: this.pageSize
        });
    };
    InfiniteScrollDirective.prototype.onScrollContainer = function (event) {
        if (this.element.scrollHeight > this.lastCheckedHeight) {
            this.previousScrollHeight = this.element.scrollHeight;
            var remainingHeight = this.element.scrollHeight - (this.element.offsetHeight + this.element.scrollTop);
            var remainingElement = Math.ceil(remainingHeight / this.eachElementHeightInPx);
            if (remainingElement < this.fetchThreshold) {
                this.lastCheckedHeight = this.element.scrollHeight;
                this.fetchMore.emit();
            }
        }
        else if (this.element.scrollHeight < this.previousScrollHeight) { // To check if the list is reloaded
            this.previousScrollHeight = this.element.scrollHeight;
            this.lastCheckedHeight = 0;
            this.element.scrollTop = 0; // Scroll the list to top
        }
    };
    __decorate([
        Output('initItems'),
        __metadata("design:type", Object)
    ], InfiniteScrollDirective.prototype, "initItems", void 0);
    __decorate([
        Output('fetchMore'),
        __metadata("design:type", Object)
    ], InfiniteScrollDirective.prototype, "fetchMore", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], InfiniteScrollDirective.prototype, "eachElementHeightInPx", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], InfiniteScrollDirective.prototype, "fetchThreshold", void 0);
    __decorate([
        HostListener('scroll', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], InfiniteScrollDirective.prototype, "onScrollContainer", null);
    InfiniteScrollDirective = __decorate([
        Directive({
            selector: '[almInfiniteScroll]',
            exportAs: 'almInfiniteScroll'
        }),
        __metadata("design:paramtypes", [ElementRef])
    ], InfiniteScrollDirective);
    return InfiniteScrollDirective;
}());
export { InfiniteScrollDirective };
//# sourceMappingURL=infinitescroll.directive.js.map