import { AfterViewChecked, ChangeDetectorRef, ElementRef, EventEmitter, OnChanges, OnInit, SimpleChanges } from '@angular/core';
import { SafeHtml } from '@angular/platform-browser';
export declare class MarkdownComponent implements OnChanges, OnInit, AfterViewChecked {
    private cdr;
    private elementRef;
    fieldName: string;
    inpRenderedText: string | SafeHtml;
    inpRawText: string;
    rendering: boolean;
    saving: boolean;
    placeholder: string;
    editAllow: boolean;
    renderedHeight: number;
    allowEmptySave: boolean;
    onActiveEditor: EventEmitter<{}>;
    onSaveClick: EventEmitter<{}>;
    showPreview: EventEmitter<{}>;
    onCloseClick: EventEmitter<{}>;
    onClickOut: EventEmitter<{}>;
    onClick(target: HTMLElement): void;
    editorInput: ElementRef;
    editorBox: ElementRef;
    previewArea: ElementRef;
    boxHeight: number;
    enableShowMore: boolean;
    renderedText: any;
    rawText: string;
    fieldEmpty: boolean;
    previousRawText: string;
    isNoDataChanged: boolean;
    private markdownViewExpanded;
    private tabBarVisible;
    private viewType;
    private editorActive;
    private showMore;
    private inputsDisabled;
    private previousRenderedText;
    constructor(cdr: ChangeDetectorRef, elementRef: ElementRef);
    ngOnChanges(changes: SimpleChanges): void;
    ngOnInit(): void;
    ngAfterViewChecked(): void;
    onInputEvent(event: any): void;
    onClickMarkdownTab(): void;
    onClickPreviewTab(): void;
    checkInputsDisabled(): void;
    setPreviewInputsDisabled(query: string, disabled: boolean): void;
    enableEditor(event: MouseEvent): void;
    activeEditor(): void;
    deactivateEditor(): void;
    saveClick(): void;
    editorKeyUp(event: Event): void;
    closeClick(): void;
    renderPreview(rawText: string, renderedText: string): void;
    saveUpdate(rawText: string, renderedText: any): void;
    lengthToggle(showMore: boolean): void;
}
